<div id="products" class="page-layout carded fullwidth" fusePerfectScrollbar>

    <!-- TOP BACKGROUND -->
    <div class="top-bg {{secondColorBrand}}"></div>
    <!-- / TOP BACKGROUND -->

    <!-- CENTER -->
    <div class="center">

        <div class="white-fg" fxLayout="column" fxLayoutAlign="center center" fxLayout.gt-xs="row" fxLayoutAlign.gt-xs="space-between center"
            style="padding-top: 20px;">

            <!-- APP TITLE -->
            <div class="logo my-12 m-sm-0" fxLayout="row" fxLayoutAlign="start center">
                <mat-icon class="logo-icon mr-16" *fuseIfOnDom [@animate]="{value:'*',params:{delay:'50ms',scale:'0.2'}}">gps_fixed</mat-icon>
                <span class="logo-text h1" *fuseIfOnDom [@animate]="{value:'*',params:{delay:'100ms',x:'-25px'}}">Rastreadores</span>
            </div>

            <!-- SEARCH -->
            <div class="search-input-wrapper mx-6  m-md-0" fxFlex="1 0 auto" fxLayout="row" fxFlex="50" fxLayoutAlign="start center">
                <label for="search" class="mr-6">
                    <mat-icon class="secondary-text">search</mat-icon>
                </label>
                <mat-form-field floatPlaceholder="never" fxFlex="1 0 auto">
                    <input id="search" matInput (keyup)='searchOnChange($event)' placeholder="Filtrar">
                </mat-form-field>
            </div>
            <!-- /SEARCH -->

            <button mat-raised-button color="primary" [ngClass]="primaryColorBrand"
                [routerLink]="'/devices/new'">
                <span>NOVO RASTREADOR</span>
            </button>
        </div>
        
        <!-- HEADER -->
        <div class="white-fg" fxLayout="column" fxLayoutAlign="center center" fxLayout.gt-xs="row" style="padding-bottom: 5px;"
            fxLayoutAlign.gt-xs="space-between center">

            <div class="search-input-wrapper mx-6 m-md-0" fxFlex="1 0 auto" fxLayout="row" fxLayoutAlign="start center">

                <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="20">
                        <mat-select placeholder="Modelo" formControlName="model">
                            <mat-option value="">Todos</mat-option>
                            <mat-option *ngFor="let device of deviceModelList" [value]="device.key">
                                    {{ device.value }}
                            </mat-option>
                            
                        </mat-select>
                    </mat-form-field>


                    <mat-form-field fxFlex="15">
                        <mat-select placeholder="Status" formControlName="status">
                            <mat-option value="">Todos</mat-option>
                            <mat-option *ngFor="let status of statusList" [value]="status.key">
                                {{ status.value }}
                            </mat-option>
                        </mat-select>
                    </mat-form-field>

                    <mat-form-field fxFlex="15">
                        <mat-select placeholder="Marca" formControlName="brand">
                            <mat-option *ngFor="let item of brandList" [value]="item.id">
                                {{ item.name }}
                            </mat-option>
                        </mat-select>

                    </mat-form-field>

                    <mat-form-field fxFlex="25" fxLayoutAlign="center center">
                        <input matInput class="white-fg" [matDatepicker]="startDate" placeholder="Período Inicial"
                            formControlName="startDate">
                        <mat-datepicker-toggle class="light-blue-fg" matSuffix [for]="startDate"></mat-datepicker-toggle>
                        <mat-datepicker #startDate disabled="false"></mat-datepicker>
                    </mat-form-field>

                    <mat-form-field fxFlex="25" fxLayoutAlign="center center">
                        <input matInput class="white-fg" [matDatepicker]="endDate" placeholder="Período Final"
                            formControlName="endDate">
                        <mat-datepicker-toggle class="light-blue-fg" matSuffix [for]="endDate"></mat-datepicker-toggle>
                        <mat-datepicker #endDate disabled="false"></mat-datepicker>
                    </mat-form-field>

                    <div fxLayout="row" fxLayoutAlign="center center" fxLayoutGap="10px">
                        <button mat-raised-button style="width: 60%" class="mat-accent mr-16" (click)="onListValueChanged()">
                            <span>Filtrar</span>
                        </button>
                    </div>
                    <!-- </div> -->
                </form>
            </div>
        </div>

        <!-- / HEADER -->

        <!-- CONTENT CARD -->
        <div class="content-card mat-white-bg" >

            <mat-table #table class="products-table" [dataSource]="dataSource" [@animateStagger]="{value:'50'}" matSort
                matSortActive="id" matSortDirection="asc" matSortDisableClear>


                <ng-container cdkColumnDef="statusColor">
                    <mat-header-cell *cdkHeaderCellDef class="white-fg"></mat-header-cell>
                    <mat-cell *cdkCellDef="let element" [ngClass]="deviceColorStatusEnumToString(element.status)">

                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="space">
                    <mat-header-cell *cdkHeaderCellDef class="white-fg"></mat-header-cell>
                    <mat-cell *cdkCellDef="let element">

                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="conection">
                    <mat-header-cell *cdkHeaderCellDef class="white-fg">Conexão</mat-header-cell>
                    <mat-cell *cdkCellDef="let element">
                        <mat-icon class="green-fg">mobile_friendly</mat-icon>
                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="imei">
                    <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Imei</mat-header-cell>


                    <mat-cell *cdkCellDef="let element">
                        <p class="text-truncate">{{element.imei}}</p>
                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="model">
                    <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Modelo</mat-header-cell>
                    <mat-cell *cdkCellDef="let element">
                        <p class="text-truncate">{{element.model}}</p>
                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="brand">
                    <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Marca</mat-header-cell>
                    <mat-cell *cdkCellDef="let element">
                        <p class="text-truncate">{{element.brandObj?.name}}</p>
                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="licensePlate">
                    <mat-header-cell *cdkHeaderCellDef class="white-fg">Placa do Veículo</mat-header-cell>
                    <mat-cell *cdkCellDef="let element">
                        <p class="text-truncate">{{element?.relationships?.vehicle ?
                            element?.relationships?.vehicle.licensePlate : '-'}}</p>
                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="status">
                    <mat-header-cell *cdkHeaderCellDef mat-sort-header style="text-align: center" class="white-fg">Status</mat-header-cell>

                    <mat-cell *cdkCellDef="let element" style="text-align: center">
                        <mat-chip-list>
                            <mat-chip [ngClass]="deviceColorStatusLightEnumToString(element.status)" style="width:80px; text-align: center;"
                                selected> {{ deviceActivityToString(element.status)}}</mat-chip>
                        </mat-chip-list>
                    </mat-cell>
                </ng-container>

                <ng-container cdkColumnDef="lifecycle.activeDate">
                    <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">{{statusDevice}}</mat-header-cell>
                    <mat-cell *cdkCellDef="let element">
                        <p class="text-truncate">{{getLifecycle(element)}}</p>
                        <!-- element?.lifecycle?.activeDate ? (element?.lifecycle?.activeDate | date: 'dd/MM/yyyy') : '-' -->
                    </mat-cell>
                </ng-container>
                
                <mat-header-row *cdkHeaderRowDef="displayedColumns" [ngClass]="primaryColorBrand"></mat-header-row>

                <mat-row *cdkRowDef="let row; columns: displayedColumns;" class="product" [ngClass]="{'mat-accent-50-bg':row == selected}"
                    matRipple [@animate]="{value:'*',params:{y:'100%'}}" (click)="selectDevice(row)" matRipple>
                </mat-row>

            </mat-table>

            <mat-paginator [length]="resultLength" [pageSize]="10" [pageSizeOptions]="[10, 25, 50]"></mat-paginator>

        </div>

        
        <!-- / CONTENT CARD -->
    </div>
    <!-- / CENTER -->
</div>